
/*
 *  Copyright (C) 2010-2011 Oracle Corporation
 *
 *  This file is part of the VirtualBox SDK, as available from
 *  http://www.virtualbox.org.  This library is free software; you can
 *  redistribute it and/or modify it under the terms of the GNU Lesser General
 *  Public License as published by the Free Software Foundation, in version 2.1
 *  as it comes in the "COPYING.LIB" file of the VirtualBox SDK distribution.
 *  This library is distributed in the hope that it will be useful, but WITHOUT
 *  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
 *  License for more details.
 *
 * IVBoxSVCAvailabilityChangedEvent.java
 *
 * DO NOT EDIT! This is a generated file.
 * Generated from: src/VBox/Main/idl/VirtualBox.xidl (VirtualBox's interface definitions in XML)
 * Generator: src/VBox/Main/glue/glue-java.xsl
 */

package org.virtualbox_4_1;

import org.virtualbox_4_1.jaxws.*;
import javax.xml.ws.*;
import java.util.List;

/**

      Notification when VBoxSVC becomes unavailable (due to a crash or similar
      unexpected circumstances) or available again.
    
Interface ID: <tt>{97C78FCD-D4FC-485F-8613-5AF88BFCFCDC}</tt>
*/
public class IVBoxSVCAvailabilityChangedEvent extends IEvent {

    public IVBoxSVCAvailabilityChangedEvent(String wrapped, VboxPortType port) {
          super(wrapped, port);
    }
/**

        Whether VBoxSVC is available now.
      
@return Boolean

*/
    public Boolean getAvailable() {
      try {
         Boolean retVal = port.ivBoxSVCAvailabilityChangedEventGetAvailable(obj);
         return retVal;
     } catch (InvalidObjectFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     } catch (RuntimeFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     }
    }
    public static IVBoxSVCAvailabilityChangedEvent queryInterface(IUnknown obj) {
       return obj == null ?  null : new IVBoxSVCAvailabilityChangedEvent(obj.getWrapped(), obj.getRemoteWSPort());
    }
}
